
require 'swf'

m = Swf::Movie.new
m.rate = 36.0
m.set_dimension 1200, 800
m.set_background 0, 0, 0

# mouse tracking sprite - empty, but follows mouse so we can
# get its x and y coordinates

i = m.add Swf::MovieClip.new
i.name = 'mouse'

# '1' means lock sprite to the mouse
m.add Swf::Action.new "startDrag('/mouse', 1);"

# might as well turn off antialiasing, since these are just squares.
m.add Swf::Action.new "this.quality = 0;"

# morphing box
r = Swf::Morph.new

s = r.shape1
s.set_left_fill s.add_solid_fill 0xff, 0xff, 0xff
s.move_pen_to -40, -40
s.draw_line +80,   0
s.draw_line   0, +80
s.draw_line -80,   0
s.draw_line   0, -80

s = r.shape2
s.set_left_fill s.add_solid_fill 0x00, 0x00, 0x00
s.move_pen_to  -1,  -1
s.draw_line  +2,   0
s.draw_line   0,  +2
s.draw_line  -2,   0
s.draw_line   0,  -2

# sprite container for morphing box -
# this is just a timeline w/ the box morphing

box = Swf::MovieClip.new
box.add Swf::Action.new "stop();"
i = box.add r

for n in 0..20
  i.ratio = n/20.0
  box.next_frame
end

# this container sprite allows us to use the same action code many times

cell = Swf::MovieClip.new
i = cell.add box
i.name = 'box'

# ...x means the x coordinate of the parent, i.e. (..).x
cell.add Swf::Action.new <<EOT
  setTarget('box');
  dx = (/mouse.x + random(6)-3 - ...x)/5;
  dy = (/mouse.y + random(6)-3 - ...y)/5;
  gotoFrame(int(dx*dx + dy*dy));
EOT

cell.next_frame
cell.add Swf::Action.new "gotoFrame(0); play();"

cell.next_frame

# finally, add a bunch of the cells to the movie

for x in 0...12
  for y in 0...8
    i = m.add cell
    i.move_to 100*x+50, 100*y+50
  end
end

m.next_frame

m.add Swf::Action.new "gotoFrame(1); play();"

m.save "test.swf"
