#include "init.h"

void
swf_no_shape()
{
	rb_raise(rb_eRuntimeError, "already closed shape");
}

static void
swf_free_shape(p)
	SWFShape p;
{
	Debug("swf free shape");
	destroySWFShape(p);
}

static VALUE
swf_shape_new(self)
	VALUE self;
{
	VALUE obj;
	
	SWFShape p;
	p = newSWFShape();
	obj = Data_Wrap_Struct(self, 0, swf_free_shape, p);
	return obj;
}

VALUE
swf_shape_alloc(self, p)
	VALUE self;
	SWFShape p;
{
	VALUE obj;
	
	obj = Data_Wrap_Struct(self, 0, 0, p);
	return obj;
}

static VALUE
swf_shape_move_pen(self, x, y)
	VALUE self, x, y;
{
	SWFShape p;
	
	GetShape(self, p);
	SWFShape_moveToRelative(p, NUM2INT(x), NUM2INT(y));
	return Qnil;
}

static VALUE
swf_shape_move_pen_to(self, x, y)
	VALUE self, x, y;
{
	SWFShape p;
	
	GetShape(self, p);
	SWFShape_moveTo(p, NUM2INT(x), NUM2INT(y));
	return Qnil;
}

static VALUE
swf_shape_draw_line(self, x, y)
	VALUE self, x, y;
{
	SWFShape p;
	
	GetShape(self, p);
	SWFShape_lineToRelative(p, NUM2INT(x), NUM2INT(y));
	return Qnil;
}

static VALUE
swf_shape_draw_line_to(self, x, y)
	VALUE self, x, y;
{
	SWFShape p;
	
	GetShape(self, p);
	SWFShape_lineTo(p, NUM2INT(x), NUM2INT(y));
	return Qnil;
}

static VALUE
swf_shape_draw_curve_to(self, controlx, controly, anchorx, anchory)
	VALUE self, controlx, controly, anchorx, anchory;
{
	SWFShape p;
	
	GetShape(self, p);
	SWFShape_curveTo(p, 
		NUM2INT(controlx),
		NUM2INT(controly),
		NUM2INT(anchorx),
		NUM2INT(anchory));
	return Qnil;
}

static VALUE
swf_shape_add_solid_fill(argc, argv, self)
	int argc;
	VALUE* argv;
	VALUE self;
{
	SWFShape p;
	SWFFill p_fill;
	VALUE r, g, b, a;
	
	if (rb_scan_args(argc, argv, "31", &r, &g, &b, &a) == 3)
		a = INT2FIX(0xff);
	
	GetShape(self, p);
	p_fill = SWFShape_addSolidFill(p, 
		(byte)(NUM2CHR(r)),
		(byte)(NUM2CHR(g)),
		(byte)(NUM2CHR(b)),
		(byte)(NUM2CHR(a)));
	return swf_fill_alloc(cSwf_fill, p_fill);
}

static VALUE
swf_shape_add_gradient_fill(argc, argv, self)
	int argc;
	VALUE* argv;
	VALUE self;
{
	SWFShape p;
	SWFGradient p_gradient;
	SWFFill p_fill;
	VALUE gradient, flags;
	
	if (rb_scan_args(argc, argv, "11", &gradient, &flags) == 1)
		flags = INT2FIX(SWFFILL_LINEAR_GRADIENT);
	
	GetShape(self, p);
	GetGradient(gradient, p_gradient);
	
	p_fill = SWFShape_addGradientFill(p, 
		p_gradient,
		(byte)(NUM2CHR(flags)));
	return swf_fill_alloc(cSwf_fill, p_fill);
}

static VALUE
swf_shape_add_bitmap_fill(argc, argv, self)
	int argc;
	VALUE* argv;
	VALUE self;
{
	SWFShape p;
	SWFBitmap p_bitmap;
	SWFFill p_fill;
	VALUE bitmap, flags;
	
	if (rb_scan_args(argc, argv, "11", &bitmap, &flags) == 1)
		flags = INT2FIX(SWFFILL_CLIPPED_BITMAP);
	
	GetShape(self, p);
	GetBitmap(bitmap, p_bitmap);
	
	p_fill = SWFShape_addBitmapFill(p, 
		p_bitmap,
		(byte)(NUM2CHR(flags)));
	return swf_fill_alloc(cSwf_fill, p_fill);
}

static VALUE
swf_shape_set_left_fill(self, fill)
	VALUE self, fill;
{
	SWFShape p;
	SWFFill p_fill;
	
	GetShape(self, p);
	GetFill(fill, p_fill);
	
	SWFShape_setLeftFill(p, p_fill);
	return Qnil;
}

static VALUE
swf_shape_set_right_fill(self, fill)
	VALUE self, fill;
{
	SWFShape p;
	SWFFill p_fill;
	
	GetShape(self, p);
	GetFill(fill, p_fill);
	
	SWFShape_setRightFill(p, p_fill);
	return Qnil;
}

static VALUE
swf_shape_draw_rect(self, rect)
	VALUE self, rect;
{
	SWFShape p;
	SWFRect p_rect;
	
	GetShape(self, p);
	GetRect(rect, p_rect);
	
	SWFShape_drawRect(p, p_rect);
	return Qnil;
}

static VALUE
swf_shape_set_line(argc, argv, self)
	int argc;
	VALUE* argv;
	VALUE self;
{
	SWFShape p;
	VALUE width, r, g, b, a;
	
	if (rb_scan_args(argc, argv, "41", &width, &r, &g, &b, &a) == 4)
		a = INT2FIX(0xff);
	
	GetShape(self, p);
	SWFShape_setLine(p, 
		(unsigned short)(NUM2INT(width)),
		(byte)(NUM2CHR(r)),
		(byte)(NUM2CHR(g)),
		(byte)(NUM2CHR(b)),
		(byte)(NUM2CHR(a)));
	return Qnil;
}

static VALUE
swf_shape_draw_arc(self, r, start, end)
	VALUE self, r, start, end;
{
	SWFShape p;
	
	GetShape(self, p);
	SWFShape_drawArc(p, 
		NUM2INT(r),
		NUM2DBL(start),
		NUM2DBL(end));
	return Qnil;
}

static VALUE
swf_shape_draw_circle(self, r)
	VALUE self, r;
{
	SWFShape p;
	
	GetShape(self, p);
	SWFShape_drawCircle(p, NUM2INT(r));
	return Qnil;
}

static VALUE
swf_shape_draw_glyph(self, font, c)
	VALUE self, font, c;
{
	SWFShape p;
	SWFFont p_font;
	
	GetShape(self, p);
	GetFont(font, p_font);
	SWFShape_drawFontGlyph(p, p_font, NUM2CHR(c));
	return Qnil;
}

void
swf_init_shape()
{
	cSwf_shape = rb_define_class_under(mSwf, "Shape", rb_cObject);
	rb_define_singleton_method(cSwf_shape, "new", swf_shape_new, 0);
	rb_define_method(cSwf_shape, "move_pen", swf_shape_move_pen, 2);
	rb_define_method(cSwf_shape, "move_pen_to", swf_shape_move_pen_to, 2);
	rb_define_method(cSwf_shape, "draw_line", swf_shape_draw_line, 2);
	rb_define_method(cSwf_shape, "draw_line_to", swf_shape_draw_line_to, 2);
	rb_define_method(cSwf_shape, "draw_curve_to", swf_shape_draw_curve_to, 4);
	rb_define_method(cSwf_shape, "add_solid_fill", swf_shape_add_solid_fill, -1);
	rb_define_method(cSwf_shape, "add_gradient_fill", swf_shape_add_gradient_fill, -1);
	rb_define_method(cSwf_shape, "add_bitmap_fill", swf_shape_add_bitmap_fill, -1);
	rb_define_method(cSwf_shape, "set_left_fill", swf_shape_set_left_fill, 1);
	rb_define_method(cSwf_shape, "set_right_fill", swf_shape_set_right_fill, 1);
	rb_define_method(cSwf_shape, "draw_rect", swf_shape_draw_rect, 1);
	rb_define_method(cSwf_shape, "set_line", swf_shape_set_line, -1);
	rb_define_method(cSwf_shape, "draw_arc", swf_shape_draw_arc, 3);
	rb_define_method(cSwf_shape, "draw_circle", swf_shape_draw_circle, 1);
	rb_define_method(cSwf_shape, "draw_glyph", swf_shape_draw_glyph, 2);
}
